#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>
#include <stdint.h>
#include <stddef.h>
#include <string.h>

#define ALGOINFOMAXLEN 1024

//#pragma pack(1)

struct algoinfo {
 char text[ALGOINFOMAXLEN];
 unsigned int len;
} __attribute__((packed));

//#pragma pack()

int main(int argn, char *argv[])
{
	void *libhnd;
	void (*algoinfofunc)(struct algoinfo *);

    struct algoinfo ai;
    
	libhnd=dlopen("./SCD_rtccode_02_02.so", RTLD_LAZY | RTLD_GLOBAL);
	if(libhnd==NULL)
	{
		printf("Error loading .so\n");
		exit(0); 
	}
 
	algoinfofunc=dlsym(libhnd, "SCD_rtccode_02_02_GetAlgoInfo");
	if(algoinfofunc==NULL)
	{
		printf("Error loading SCD_rtccode_02_02_GetAlgoInfo\n");
		perror(NULL);
		exit(0);
	}

    (*algoinfofunc)(&ai);
    
    printf("%d, %s\n", ai.len, ai.text);
    

}
